/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */

#ifndef _JS_TOKEN_STREAM_P_H_
#define _JS_TOKEN_STREAM_P_H_

#include "js-utils.h"
#include "js-hashtable.h"
#include "js-tokenstream.h"

#ifdef VX
 #include "ewb-mem.h"
#endif


/* Typedefs */
typedef struct {
    jsString_t	string;
    int		value;
} JSKeyword;
#ifdef VX
class JSKeywordAllocator {
    public:
#ifdef VX
	void* allocate( size_t size ){
		//return EwbMalloc( size );
		//return new uint8_t[size];
		return malloc( size );
	}
	void deallocate( void* obj ){
		//EwbMFree( ptr );
		//delete obj;
		free (obj);
		return;
	}
#else
        void    *allocate(size_t size) {
            return new uint8_t[size];
        }
        void    deallocate(void *obj) {
            delete obj;
        }
#endif
} ;
typedef JSHashtable<int, jsString_t, JSKeywordAllocator> _JSKeywordHashtable;
class JSKeywordHashtable: public _JSKeywordHashtable {
    public:
	inline void* operator new(size_t size){
		//	return EwbMalloc( size );
		return malloc( size );
	}
	inline void* operator new[](size_t size) {
		//	return EwbMalloc( size );
		return malloc( size );
	}
	inline void operator delete( void* ptr ){
		//	if( ptr ) EwbMFree( ptr );
		return free( ptr );
	}
	inline void operator delete[]( void* ptr ){
		//	if( ptr ) EwbMFree( ptr );
		return free( ptr );
	}

    protected:
        static  size_t hashCode(jsString_t key) {
            return (size_t) (key[0] & 0xff);
        }
        static  int cmpKey(jsString_t key1, jsString_t key2) {
            return strcmp(key1, key2);
        }
        static void dupEntry(JSKeywordHashtable::HashtableEntry *dst,
                        JSKeywordHashtable::HashtableEntry *src,
                        JSKeywordAllocator *allocator) {
            *dst = *src;
        }
        static void destroyEntry(JSKeywordHashtable::HashtableEntry *tabEntry,
                        JSKeywordAllocator *allocator) {
            allocator->deallocate(tabEntry);
        }
 
    public:
        JSKeywordHashtable(JSKeywordAllocator *allocator)
                : _JSKeywordHashtable(hashCode, cmpKey, dupEntry, destroyEntry,
                        allocator) {
        }
} ;
#endif /* VX */

#endif /* _JS_TOKEN_STREAM_P_H_ */

